# 技術評論社刊
# WEB+DB PRESS Vol.77
# 特集1: スマートフォンテスト最前線
# 第2章 サンプルコード

本ファイルではダウンロードパッケージに含まれるサンプルコードとその利用方法について説明します。

## ファイル構成


```
.
├── README.md				// このファイル
├── LICENSE.txt					// ライセンス説明
├── eclipse-1.0.txt				// EPL 1.0  (txt)
├── testGameApp				// ゲームアプリのテスト
│   ├── SampleGame.feature		// フィーチャファイル
│   └── step_definiton.rb			// ステップ実装ファイル
└── testUIApp					// UIアプリのテスト
    ├── SimpleForm				// テストアプリのコード
    ├── SimpleForm.xcodeproj		// テストアプリのxcodeproj
    ├── calabash.framework		// calabash.framework
    └── features					// フィーチャ、ステップ実装、サポートファイル群
        ├── my_first.feature			// フィーチャファイル
        ├── step_definitions
        │   └── my_first_steps.rb	// ステップ実装ファイル
        └── support				// サポート実装ファイル
```

　「CalabashによるUIアプリケーションのテスト」のサンプルコードは calabash-ios 環境で作成されいるため、実行には Mac OS、及び iOS開発環境の Xcode が必要です。こちらにはテスト用のUIアプリケーションも含まれています。

　「Calabashによるゲームアプリのテスト」のサンプルコードは calabash-android 環境向けに作成しているため、実行には Android SDK が必要です。
　また、紙面でサンプルとして利用したゲームアプリは DeNA により提供されている ngCore SDK に含まれるサンプル・アプリケーションです。このサンプル・アプリケーションを入手、動作させるには以下のサイトで開発者登録を行い、開発者向けドキュメントを参照してください。

* https://developer.dena.jp/mbga/admin/sdk?lang=ja
* https://developer.mobage.com/ja/portal/downloads


## UIアプリケーションのテスト実行方法
iOS向けのサンプルUIアプリケーションとCalabashによるテストのビルドと実行に必要なファイルが含まれており、以下の手順で実行してください。

1. SimpleForm.xcodeproj を Xcode で開く
2. Build で一度ビルドして、シミュレータにインストールしておく
3. Ruby gem の calabash-cucumber を用意する

    gem install calabash-cucumber

4. SimpleForm ディレクトリ直下で cucumber コマンドを実行する

## Calabash をインストールする方法
本テストアプリは、calabash.framework の設定済みの状態です。既存プロジェクトに Calabash を初めて導入する方法について説明します。(2013/08/23 時点)

基本的な流れは以下の README の "Setting up Xcode project" と同様です。古い Framework が利用される場合がある部分があるため、それは以下で説明します。

https://github.com/calabash/calabash-ios

### Ruby gem calabash-cucumber のインストール
    gem install calabash-cucumber

### Calabash Framework のダウンロード
1. calabash.framework のダウンロード
  - github の README にダウンロードページがありますが、古いので gem のコマンドを使ってダウンロードします

   calabash-ios download

### Calabash Framework のインクルード
あとは、calabash.framework を xcodeproj に組み込むだけです。
Calabash の github の README を参考にして下さい。

大まかな流れは以下です。

1. ダウンロードした calabash.framework をドラッグアンドドロップで追加する
2. CFNetwork.framework を追加する
3. プロジェクトの Build Settings の Other Linker Flags に以下を追加する

    -force_load "$(SRCROOT)/calabash.framework/calabash" -lstdc++

4. アプリを一度 Run して、Calabash が組み込まれたか確認する
  - 以下の様な出力が表示されます
  - 例えば "calabash" という文字列が含まれているか確認して、Calabash が正しく組み込まれているか確認して下さい

    SimpleForm[55899:c07] Creating the server: <LPHTTPServer: 0x72843a0>
    SimpleForm[55899:c07] Calabash iOS server version: 0.9.151
    SimpleForm[55899:c07] Started LPHTTP server on port 37265
    SimpleForm[55899:2003] Bonjour Service Published: domain(local.) type(_http._tcp.) name(Calabash Server)
